#include <stdio.h>

#include "util.h"
#include "task.h"
#include "rmscheduler.h"

int lcm( int a, int b )
{
    // lcm( a, b ) = | a * b | / gcd( a, b )
    return a * b / gcd( a, b );
}

int task_hyperperiod( Task* t, int n )
{
    // lcm( a, lcm( b, c ) ) = lcm( a, b, c )
    int ret;

    if( n == 1 )
        return t->period;

    ret = lcm( t->period, ( t + 1 )->period );

    for( int i = 2; i < n; i++)
        ret = lcm( ret, ( t + i )->period );

    return ret;
}


int main()
{
    Task task[ 3 ];

    task_set( task + 0, 5, 2, TASK_STOPPED, 0 );
    task_set( task + 1, 20, 5, TASK_STOPPED, 0 );
    task_set( task + 2, 4, 1, TASK_STOPPED, 0 );

    int h = task_hyperperiod( task, 3 );
    printf( "Hyper-period: %d\n", h );

    rm_schedule( task, 3, h );
}
