#ifndef TASK_H
#define TASK_H

#include <stdlib.h>
#include <stdio.h>

typedef enum {
    TASK_READY = 0,
    TASK_RUNNING = 1,
    TASK_STOPPED = 2
} TaskState;

typedef struct Task {
    int period; // period
    int exectime; // execution time
    TaskState state; // current state of the task
    int remtime; // remaining execution time
} Task;

inline static void task_set( Task* t, int period, int exectime, TaskState state, int remtime )
{
    t->period = period;
    t->exectime = exectime;
    t->state = state;
    t->remtime = remtime;
}

inline static void task_print( Task* t, int n )
{
    const char* STATESTR[] = { "READY", "RUNNING", "STOPPED" };
    for( int i = 0; i < n; i++ )
        printf("Task %d: (%d,%d) %s\n", i + 1, ( t + i )->period, ( t + i )->exectime, STATESTR[ ( t +i )->state ] );
}

inline static int task_compare_rate( const Task* t1, const Task* t2 )
{
    return t1->period - t2->period;
}

inline static void task_sort_rate( Task* t, int n )
{
    qsort( ( void* ) t, n, sizeof( Task ), ( int (*)(const void *, const void *) ) task_compare_rate );
}

#endif
